/** C++ Interface: simstream
//
// Description: 
//
//
// Author: Georgios Kioumourtzis <gkioumou@gmail.com>, (C) 2008
//
 * Copyright (c) 2007 University of Patras Computer Engineering and Informatics Department Greece
 *
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *
 * 4. Neither the name of the University nor of the Research Group may be
 *    used to endorse or promote products derived from this software without
 *    specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifndef ns_assp_agent_h
#define ns_assp_agent_h


#include "config.h"
#include "object.h"
#include "agent.h"
#include "timer-handler.h"
#include <list>	
#include "rtp.h"
#include "vbr_rateadapt.h"

class vbr_rateadapt2;
class RTPSession;
class ASSPAgent;
class JoinTimer : public TimerHandler {
public: 
        JoinTimer(ASSPAgent *a) : TimerHandler() { a_ = a; }
protected:
        virtual void expire(Event *e);
        ASSPAgent *a_;
};



class ASSPAgent : public TclObject {
public:
	ASSPAgent();
	~ASSPAgent();
	
	RTPSession* sessions_;
	vbr_rateadapt2* all_vbrs_;
	/* connection with TCL commands */
	int command(int argc, const char*const* argv);
	void set_frametype(u_int32_t q_level, int fr_type);
	void send(u_int32_t q_level, int nbytes, int frame_number);
	void set_quant(u_int32_t q_level, int quant);
	void set_new_tx_rate(int quality_level, double newRate);
	void set_Avg_tx(int quality_level, double rate);
	virtual void join_timeout(int);
	JoinTimer join_timer_;
	double get_low();
	double get_medium();
	double get_high();
	
	
	
	
		

protected:
	// functions
	void enter(RTPSession*);
	void enter(vbr_rateadapt2*);
	vbr_rateadapt2* lookup(u_int32_t);
	void start_timer(int a);
	
	// fields
	int streamid_;
	int timeout;
	double low_tx, medium_tx, high_tx;
	
	

	
};


#endif
