/** C++ Interface: simstream
//
// Description: 
//
//
// Author: Georgios Kioumourtzis <gkioumou@gmail.com>, (C) 2008
//
 * Copyright (c) 2007 University of Patras Computer Engineering and Informatics Department Greece
 *
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *
 * 4. Neither the name of the University nor of the Research Group may be
 *    used to endorse or promote products derived from this software without
 *    specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifndef ns_assp_sink_h
#define ns_assp_sink_h


#include "config.h"
#include "object.h"
#include "agent.h"
#include "timer-handler.h"
#include <list>	
#include "rtp.h"

class RTPSession;


class ASSPSink : public TclObject {
public:
	ASSPSink();
	~ASSPSink();
	
	RTPSession* sessions_;
	/* connection with TCL commands */
	int command(int argc, const char*const* argv);
	void rcv(Packet* p);
	void setLow_tx(double value);
	void setMedium_tx(double value);
	void setHigh_tx(double value);
	void setInst_rx_rate(double value);
	void compare();
	void set_int_rate(double value);
	
	
		

protected:
	void enter(RTPSession*);
	void go_up(int level);
	void go_down(int level);
	

	
	/** the stream id */
	int streamid_;
	int seqno_;
// 	int frame_type_;
	//added by smallko
	int id_;	
	char BWfile[100];
	FILE *BWFile;
	int openfile;
	//Sink functions
	int expected_;
	double low_tx, medium_tx, high_tx;
	double rx_rate;
	int level_;
	double rcv_bytes;
	/** the low linit of the low capacity stream */ 
	double low_threshold;
	/** the low linit of the medium capacity stream */ 
	double medium_threshold;
	/** the low linit of the high capacity stream */ 
	double high_threshold;
	
	
	
};




#endif

