#!/bin/bash
# This script is for generating PSNR values when having PlayOut TIME constraint
#
# Input parameters:
# $1 = base name (to be used for m4v assembled file, decoded and fixed decoded file)
# $2 = PoD time (ms)
et_ra sd_be_0 rd_be_0 st_$1.yuv_Q2.txt video2.dat $1.yuv_Q 2 31 frame_size.dat $1.m4v 01
echo "et_ra finished, $1.m4v created"
#MP4box -fps 30 -add $1.m4v $1.mp4
mp4creator60 -r 30 -c $1.m4v $1rx.mp4
rm $1.m4v
ffmpeg -r 30 -i $1rx.mp4 -r 30 $1rx.yuv
rm $1rx.mp4
fixyuv_ra sd_be_0 rd_be_0 new_st.txt $1rx.yuv $1_PoD$2.yuv $2
rm $1rx.yuv
# The following assumed that folder psnr2mos already exists
psnr 352 288 420 $1.yuv $1_PoD$2.yuv > psnr2mos/psnr_$1_PoD$2.txt
#rm $1_PoD$2.yuv
# Second argument to mos.exe is a psnr reference file that is used by the miv.exe program.
# The mos program outputs miv reference files, while the MOS results are sent to stdout.
# mos <dir> <ref> [iv] > mos.txt
#  dir           directory with psnr*.txt files
#  ref           reference psnr file
#  iv            optional nr. of frames in interval
# MOS calculates the average MOS of every psnr file (last column of mos.txt) and the
# percentage of frames with a MOS worse than in the reference file in a 
# sliding interval of [iv] frames. These latter percentages are stored in miv_* files (* identical
# to the psnr_* files). E.g.:
mos psnr2mos psnr_single_ref_1e6_PoD1000.txt 25
#miv <dir>
#  dir           directory with miv*.txt files
# MIV is using the output miv_* files from MOS to search for the maximum percentage of MOS worse
# than original (i.e. reference file). E.g., if the transmission was bad (i.e. either
# low bandwidth pr packet loss or delay) around frame 1000-1025 (while the rest of 
# transmission was better), with 24 out of 25 frames having MOS worse than original file, 
# the MIV result for this file is 24/25 = 96%. E.g.:
miv psnr2mos
# runs the MIV test for all miv_* files found in directory psnr2mos.