/*
 * trace_file.cc
 *
 *  Created on: Feb 7, 2009
 *      Author: Georgios Kioumourtzis
 */

#include "trace_file.h"
#include <string.h>

TraceFile::TraceFile() :
	trace_sd0(0), trace_sd1(0), trace_sd2(0), trace_rd(0) {
	nrec_rd = nrec_sd0 = nrec_sd1 = nrec_sd2 = 0;

}

TraceFile::~TraceFile() {

}

void TraceFile::read_sd(int id, FILE* fp) {
	//	printf("Inside TraceFile::read_sd() \n");


	int i;

	char tracestring[1000], *tracevalue;

	int nrec_ = 0;
	while (!feof(fp)) {
		//   fscanf(fp, "%ld%ld%ld%ld%ld", &time, &size, &type, &max, &source);
		// if (fgets(tracestring,1000,fp) == NULL)
		//   printf("error, trace file is empty?\n");
		// else
		fgets(tracestring, 1000, fp);
		nrec_++;
	}
	nrec_ = nrec_ - 1;

	//	printf("%d records\n", nrec_);


	/*
	 * The following loop is for reading the tracefile (again) and store all
	 * information in memory
	 */
	rewind(fp);
	if (id == 0) {
		trace_sd0 = new tracerec_sd[nrec_];
		nrec_sd0 = nrec_;
		tracerec_sd* t0;
		/* Read whole input file and store in memory */
		for (i = 0, t0 = trace_sd0; i < nrec_; i++, t0++) {

			fgets(tracestring, 1000, fp);
			tracevalue = strtok(tracestring, " "); /* read the time */
			t0->trec_time = atof(tracevalue);

			tracevalue = strtok(NULL," "); /* read the source id */
			t0->src = atoi(tracevalue);

			tracevalue = strtok(NULL," "); /* read the frame number */
			t0->trec_fnumber = atoi(tracevalue);

			tracevalue = strtok(NULL," "); /* read the frame size per packet */
			t0->trec_size = atoi(tracevalue);

			tracevalue = strtok(NULL," "); /* read the quant */
			t0->trec_quant = atoi(tracevalue);

			tracevalue = strtok(NULL," "); /* read the frame type */
			t0->trec_type = atoi(tracevalue);

		}
		/*	for(int j =0; j<nrec_; j++) {
		 printf("%f %d %d %d %d %d \n",trace_sd0[j].trec_time,trace_sd0[j].src,trace_sd0[j].trec_fnumber,trace_sd0[j].trec_size,trace_sd0[j].trec_quant,trace_sd0[j].trec_type);
		 } */
	}
	if (id == 1) {
		trace_sd1 = new tracerec_sd[nrec_];
		nrec_sd1 = nrec_;
		tracerec_sd* t1;
		/* Read whole input file and store in memory */
		for (i = 0, t1 = trace_sd1; i < nrec_; i++, t1++) {

			fgets(tracestring, 1000, fp);
			tracevalue = strtok(tracestring, " "); /* read the time */
			t1->trec_time = atof(tracevalue);

			tracevalue = strtok(NULL," "); /* read the source id */
			t1->src = atoi(tracevalue);

			tracevalue = strtok(NULL," "); /* read the frame number */
			t1->trec_fnumber = atoi(tracevalue);

			tracevalue = strtok(NULL," "); /* read the frame size per packet */
			t1->trec_size = atoi(tracevalue);

			tracevalue = strtok(NULL," "); /* read the quant */
			t1->trec_quant = atoi(tracevalue);

			tracevalue = strtok(NULL," "); /* read the frame type */
			t1->trec_type = atoi(tracevalue);

		}
		/*	for(int j =0; j<nrec_; j++) {
		 printf("%f %d %d %d %d %d \n",trace_sd1[j].trec_time,trace_sd1[j].src,trace_sd1[j].trec_fnumber,trace_sd1[j].trec_size,trace_sd1[j].trec_quant,trace_sd1[j].trec_type);
		 } */
	}
	if (id == 2) {
		trace_sd2 = new tracerec_sd[nrec_];
		nrec_sd2 = nrec_;
		tracerec_sd* t2;
		/* Read whole input file and store in memory */
		for (i = 0, t2 = trace_sd2; i < nrec_; i++, t2++) {

			fgets(tracestring, 1000, fp);
			tracevalue = strtok(tracestring, " "); /* read the time */
			t2->trec_time = atof(tracevalue);

			tracevalue = strtok(NULL," "); /* read the source id */
			t2->src = atoi(tracevalue);

			tracevalue = strtok(NULL," "); /* read the frame number */
			t2->trec_fnumber = atoi(tracevalue);

			tracevalue = strtok(NULL," "); /* read the frame size per packet */
			t2->trec_size = atoi(tracevalue);

			tracevalue = strtok(NULL," "); /* read the quant */
			t2->trec_quant = atoi(tracevalue);

			tracevalue = strtok(NULL," "); /* read the frame type */
			t2->trec_type = atoi(tracevalue);

		}
		/*for(int j =0; j<nrec_; j++) {
		 printf("%f %d %d %d %d %d \n",trace_sd2[j].trec_time,trace_sd2[j].src,trace_sd2[j].trec_fnumber,trace_sd2[j].trec_size,trace_sd2[j].trec_quant,trace_sd2[j].trec_type);
		 } */
	}

	//	printf("leaving TraceFile::read_sd()\n");
}

void TraceFile::read_rd(FILE * fp) {
	//	printf("Inside TraceFile::read_rd() \n");
	tracerec_rd* t;
	frame_dat_rd* f;
	int i;

	char tracestring[1000], *tracevalue;

	int nrec_ = 0;
	while (!feof(fp)) {
		//   fscanf(fp, "%ld%ld%ld%ld%ld", &time, &size, &type, &max, &source);
		// if (fgets(tracestring,1000,fp) == NULL)
		//   printf("error, trace file is empty?\n");
		// else
		fgets(tracestring, 1000, fp);
		nrec_++;
	}
	nrec_ = nrec_ - 1;
	//	printf("%d records\n", nrec_);


	/*
	 * The following loop is for reading the tracefile (again) and store all
	 * information in memory
	 */
	rewind(fp);
	trace_rd = new tracerec_rd[nrec_];
	nrec_rd = nrec_;
	/* Read whole input file and store in memory */
	for (i = 0, t = trace_rd; i < nrec_; i++, t++) {

		fgets(tracestring, 1000, fp);
		tracevalue = strtok(tracestring, " "); /* read the time */
		t->trec_time = atof(tracevalue);

		tracevalue = strtok(NULL," "); /* read the source id */
		t->src = atoi(tracevalue);

		tracevalue = strtok(NULL," "); /* read the frame number */
		t->trec_fnumber = atoi(tracevalue);

		tracevalue = strtok(NULL," "); /* read the frame size per packet */
		t->trec_size = atoi(tracevalue);

		tracevalue = strtok(NULL," "); /* read the quant */
		t->trec_quant = atoi(tracevalue);

	}
	u_int32_t k = 0;
	u_int32_t size = 0;
	u_int32_t src = -1;
	RD_frame_size = fopen("rd_frame_dat", "w");
	for (int j = 0; j < nrec_; j++) {
		u_int32_t fnumber = trace_rd[j].trec_fnumber;

		if (k == fnumber) {
			size += trace_rd[j].trec_size;

		} else {
			fprintf(RD_frame_size, "%-16d %d %d\n", k, src, size);
			size = trace_rd[j].trec_size;
			int lost = fnumber - k;
			if (lost > 1) {
				while (lost > 1) {
					//	printf("fnumber %d k %d \n", fnumber, k);
					int index = (fnumber - lost) + 1;
					fprintf(RD_frame_size, "%-16d %d %d\n", index, src, 0);
					lost--;
				}
			}
			k = fnumber;
		}
		src = trace_rd[j].src;
	}
	fprintf(RD_frame_size, "%-16d %d %d\n", k, src, size);
	fclose(RD_frame_size);

	FILE *tmp;
	tmp = fopen("rd_frame_dat", "r");
	nrec_ = 0;
	while (!feof(tmp)) {

		//   fscanf(fp, "%ld%ld%ld%ld%ld", &time, &size, &type, &max, &source);
		// if (fgets(tracestring,1000,fp) == NULL)
		//   printf("error, trace file is empty?\n");
		// else
		fgets(tracestring, 1000, tmp);
		nrec_++;
	}
	nrec_ = nrec_ - 1;
	nr_frd = nrec_;
	rewind(tmp);
	frame_rd = new frame_dat_rd[nrec_];

	/* Read whole input file and store in memory */
	for (i = 0, f = frame_rd; i < nrec_; i++, f++) {

		fgets(tracestring, 1000, tmp);
		tracevalue = strtok(tracestring, " "); /* read the fnumber */
		f->fnumber = atoi(tracevalue);

		tracevalue = strtok(NULL," "); /* read the frame size  */
		f->src = atoi(tracevalue);

		tracevalue = strtok(NULL," "); /* read the frame size  */
		f->size = atoi(tracevalue);

	}
	fclose(tmp);
	//	printf("nrec_ %d\n", nrec_);

	/*		for (int j = 0; j < nrec_; j++) {
	 printf("%f %d %d %d %d  \n", trace_rd[j].trec_time, trace_rd[j].src,
	 trace_rd[j].trec_fnumber, trace_rd[j].trec_size,
	 trace_rd[j].trec_quant);
	 } */
	/*	for (int j = 0; j < nrec_; j++) {
	 printf("%d %d %d\n", frame_rd[j].fnumber,frame_rd[j].src, frame_rd[j].size);

	 }*/
	//	printf("leaving TraceFile::read_rd()\n");

}

void TraceFile::start() {

	//	printf("nrec_rd %d nrec_sd0 %d nrec_sd1 %d nrec_sd2 %d \n", nrec_rd, nrec_sd0, nrec_sd1, nrec_sd2);
	ndx_rd = ndx_sd0 = ndx_sd1 = ndx_sd2 = 0;
	id_rd = id_sd = 0;

	//	printf("ndx_rd %d ndx_sd0 %d ndx_sd1 %d ndx_sd2 %d \n", ndx_rd, ndx_sd0, ndx_sd1, ndx_sd2);
	RD_File = fopen("rd_trace", "w");
	SD_File = fopen("sd_trace", "w");
	create_sd_frame_size();
	compare();
	fclose(RD_File);
	fclose(SD_File);
	exit(1);
	//	get_next(ndx_rd);
}

void TraceFile::write_sd(u_int32_t src, u_int32_t pos) {
	//	printf("Inside TraceFile::write_sd \n");
	//	printf("%-16f id %d  udp %d   %d   %-16d\n",trace_sd0[ndx].trec_time, ndx,trace_sd0[ndx].trec_size,trace_sd0[ndx].trec_quant,trace_sd0[ndx].trec_type);
	switch (src) {
	case 0:
		for (int i = 0; i < nrec_sd0; i++) {
			if (pos == trace_sd0[i].trec_fnumber) {
				fprintf(SD_File, "%-16f id %d  udp %d   %d   %-16d\n",
						trace_sd0[i].trec_time, id_sd++,
						trace_sd0[i].trec_size, trace_sd0[i].trec_quant,
						trace_sd0[i].trec_type);
			}
		}
		break;
	case 1:
		for (int i = 0; i < nrec_sd1; i++) {
			if (pos == trace_sd1[i].trec_fnumber) {
				fprintf(SD_File, "%-16f id %d  udp %d   %d   %-16d\n",
						trace_sd1[i].trec_time, id_sd++,
						trace_sd1[i].trec_size, trace_sd1[i].trec_quant,
						trace_sd1[i].trec_type);
			}
		}

		break;
	case 2:
		for (int i = 0; i < nrec_sd2; i++) {
			if (pos == trace_sd2[i].trec_fnumber) {
				fprintf(SD_File, "%-16f id %d  udp %d   %d   %-16d\n",
						trace_sd2[i].trec_time, id_sd++,
						trace_sd2[i].trec_size, trace_sd2[i].trec_quant,
						trace_sd2[i].trec_type);
			}
		}

		break;
	default:
		printf("Error...no src found\n");
	}

	//	fclose(SD_File);
}

void TraceFile::write_rd(u_int32_t pos) {
	//	printf("Inside TraceFile::write_rd \n");
	//printf("%-16f id %d  udp %d\n", trace_rd[ndx].trec_time, ndx,trace_sd0[ndx].trec_size);
	for (int i = 0; i < nrec_rd; i++) {
		if (pos == trace_rd[i].trec_fnumber) {
			fprintf(RD_File, "%-16f id %d  udp %d\n", trace_rd[i].trec_time,
					id_rd++, trace_rd[i].trec_size);
		}
	}

	//	fclose(RD_File);
}

void TraceFile::write_lost(u_int32_t src, u_int32_t pos) {
	switch (src) {
	case 0:
		for (int i = 0; i < nrec_sd0; i++) {
			if (pos == trace_sd0[i].trec_fnumber) {
				fprintf(RD_File, "%-16f id %-16d lost  %-16d\n",
						trace_sd0[i].trec_time, id_rd++, 9999);
			}
		}

		break;
	case 1:
		for (int i = 0; i < nrec_sd1; i++) {
			if (pos == trace_sd1[i].trec_fnumber) {
				fprintf(RD_File, "%-16f id %-16d lost  %-16d\n",
						trace_sd1[i].trec_time, id_rd++, 9999);
			}
		}

		break;
	case 2:
		for (int i = 0; i < nrec_sd2; i++) {
			if (pos == trace_sd2[i].trec_fnumber) {
				fprintf(RD_File, "%-16f id %-16d lost %-16d\n",
						trace_sd2[i].trec_time, id_rd++, 9999);
			}
		}

		break;
	default:
		printf("Error...no src found\n");
	}

}

void TraceFile::create_sd_frame_size() {
	SD0_frame_size = fopen("sd0_frame_dat", "w");
	u_int32_t size_sd0 = 0;
	u_int32_t size_sd1 = 0;
	u_int32_t size_sd2 = 0;
	u_int32_t k = 0;
	frame_dat_sd* f;
	int i;
	char tracestring[1000], *tracevalue;

	for (int j = 0; j < nrec_sd0; j++) {
		u_int32_t fnumber = trace_sd0[j].trec_fnumber;

		if (k == fnumber) {
			size_sd0 += trace_sd0[j].trec_size;
		} else {
			fprintf(SD0_frame_size, "%-16d %d\n", k, size_sd0);
			size_sd0 = trace_sd0[j].trec_size;
			k = fnumber;
		}
	}
	fprintf(SD0_frame_size, "%-16d %d\n", k, size_sd0);
	fclose(SD0_frame_size);
	k = 0;
	SD1_frame_size = fopen("sd1_frame_dat", "w");
	for (int j = 0; j < nrec_sd1; j++) {
		u_int32_t fnumber = trace_sd1[j].trec_fnumber;

		if (k == fnumber) {
			size_sd1 += trace_sd1[j].trec_size;
		} else {
			fprintf(SD1_frame_size, "%-16d %d\n", k, size_sd1);
			size_sd1 = trace_sd1[j].trec_size;
			k = fnumber;
		}
	}
	fprintf(SD1_frame_size, "%-16d %d\n", k, size_sd1);
	fclose(SD1_frame_size);

	k = 0;
	SD2_frame_size = fopen("sd2_frame_dat", "w");
	for (int j = 0; j < nrec_sd2; j++) {
		u_int32_t fnumber = trace_sd2[j].trec_fnumber;

		if (k == fnumber) {
			size_sd2 += trace_sd2[j].trec_size;
		} else {
			fprintf(SD2_frame_size, "%-16d %d\n", k, size_sd2);
			size_sd2 = trace_sd2[j].trec_size;
			k = fnumber;
		}
	}
	fprintf(SD2_frame_size, "%-16d %d\n", k, size_sd2);
	fclose(SD2_frame_size);

	FILE *tmp;
	tmp = fopen("sd0_frame_dat", "r");
	int nrec_ = 0;
	while (!feof(tmp)) {

		//   fscanf(fp, "%ld%ld%ld%ld%ld", &time, &size, &type, &max, &source);
		// if (fgets(tracestring,1000,fp) == NULL)
		//   printf("error, trace file is empty?\n");
		// else
		fgets(tracestring, 1000, tmp);
		nrec_++;
	}
	nrec_ = nrec_ - 1;
	rewind(tmp);
	frame_sd = new frame_dat_sd[nrec_];

	/* Read whole input file and store in memory */
	for (i = 0, f = frame_sd; i < nrec_; i++, f++) {

		fgets(tracestring, 1000, tmp);
		tracevalue = strtok(tracestring, " "); /* read the fnumber */
		f->fnumber = atoi(tracevalue);

		tracevalue = strtok(NULL," "); /* read the frame size  */
		f->size_sd0 = atoi(tracevalue);

	}
	fclose(tmp);
	tmp = fopen("sd1_frame_dat", "r");
	for (i = 0; i < nrec_; i++) {
		fgets(tracestring, 1000, tmp);
		tracevalue = strtok(tracestring, " "); /* read the fnumber */

		tracevalue = strtok(NULL," "); /* read the frame size  */
		frame_sd[i].size_sd1 = atoi(tracevalue);

	}
	fclose(tmp);

	tmp = fopen("sd2_frame_dat", "r");
	for (i = 0; i < nrec_; i++) {
		fgets(tracestring, 1000, tmp);
		tracevalue = strtok(tracestring, " "); /* read the fnumber */

		tracevalue = strtok(NULL," "); /* read the frame size  */
		frame_sd[i].size_sd2 = atoi(tracevalue);
	}
	fclose(tmp);
	nr_fsd = nrec_;

	/*	for (i = 0; i < nrec_; i++) {
	 printf(" %d %d %d %d \n",frame_sd[i].fnumber,frame_sd[i].size_sd0,frame_sd[i].size_sd1,frame_sd[i].size_sd2);
	 } */

}

void TraceFile::compare() {
	for (int i = 0; i < nr_frd; i++) {
		u_int32_t src = frame_rd[i].src;
		switch (src) {
		case 0:
			if (frame_rd[i].size == 0) {
				write_sd(src, i);
				write_lost(src, i);
			} else {
				write_sd(src, i);
				write_rd(i);
			}
			break;
		case 1:
			if (frame_rd[i].size == 0) {
				write_sd(src, i);
				write_lost(src, i);
			} else {
				write_sd(src, i);
				write_rd(i);
			}
			break;
		case 2:
			if (frame_rd[i].size == 0) {
				write_sd(src, i);
				write_lost(src, i);
			} else {
				write_sd(src, i);
				write_rd(i);
			}
			break;
		default:
			printf("Error...no src found\n");
		}

	}
}

