/*
 * trace_file.h
 *
 *  Created on: Feb 7, 2009
 *      Author: Georgios Kioumourtzis
 */

#ifndef TRACE_FILE_H_
#define TRACE_FILE_H_

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>


struct tracerec_sd {
	double trec_time; /* sent time */
	u_int32_t src; /* source id */
	u_int32_t trec_fnumber; /* frame number */
	u_int32_t trec_size; /* frame size */
	u_int32_t trec_quant; /* quantizer scale */
	u_int32_t trec_type; /* packet type */

};


struct tracerec_rd {
 	double trec_time; /* received time */
	u_int32_t src; /* source id */
	u_int32_t trec_fnumber; /* frame number */
	u_int32_t trec_size; /* frame size */
	u_int32_t trec_quant; /* quantizer scale */
};

struct frame_dat_rd {
 	u_int32_t fnumber; /* frame number */
 	u_int32_t src; /* source id */
	u_int32_t size; /* frame size */

};

struct frame_dat_sd {
 	u_int32_t fnumber; /* frame number */
	u_int32_t size_sd0; /* frame size */
	u_int32_t size_sd1; /* frame size */
	u_int32_t size_sd2; /* frame size */

};


class TraceFile  {
public:
	TraceFile();
	~TraceFile();

//	void get_next(int&, struct tracerec&, int Q, int flag); /* called by TrafficGenerator
	void read_sd(int id, FILE* file);
	void read_rd(FILE* file);
	void start();




private:
	tracerec_sd* trace_sd0;
	tracerec_sd* trace_sd1;
	tracerec_sd* trace_sd2;
	tracerec_rd* trace_rd;
	frame_dat_rd* frame_rd;
	frame_dat_sd* frame_sd;



	void get_sd0(int pos);
	void get_sd1(int pos);
	void get_sd2(int pos);
	void write_sd(u_int32_t src, u_int32_t pos);
	void write_rd(u_int32_t pos);
	void write_lost(u_int32_t src, u_int32_t pos);
	void create_sd_frame_size();
	void compare();

	FILE *RD_File;
	FILE *SD_File;
	FILE *RD_frame_size;
	FILE *SD0_frame_size;
	FILE *SD1_frame_size;
	FILE *SD2_frame_size;
	int nrec_rd,nrec_sd0, nrec_sd1,nrec_sd2;
	int nr_frd, nr_fsd;
	int ndx_rd, ndx_sd0, ndx_sd1, ndx_sd2;
	int id_rd, id_sd;


};



#endif /* TRACE_FILE_H_ */
